(set-reader-macro \' (fn (stream c) (list (quote quote) (read stream))))

(def map (fn (list f)
	     (let ((loop (fn ((list result))
			     (if list
				 (loop (cdr list) (cons (f (car list)) result))
				 result))))
	       (loop list nil))))

