#include "lisp.h"

Pointer string(char* string, size_t length) {
  Pointer pointer = memory_new(STRING, sizeof(String) + length);
  String* str = &STRING(pointer);
  str->length = length;
  for (unsigned i = 0; i < length; i++) {
    str->data[i] = string[i];
  }

  return pointer;
}

Pointer string_push(Pointer pointer, char c) {
  pointer = memory_resize(pointer, sizeof(String) + STRING(pointer).length + 1);
  String* string = &STRING(pointer);
  string->data[string->length++] = c;
  return pointer;
}

Pointer string_clear(Pointer str) {
  STRING(str).length = 0;
  return str;
}

