#ifndef MACROS_H
#define MACROS_H

#define CONS(p)         (mem_get(p)->data->cons)
#define NUMBER(p)       (mem_get(p)->data->number)
#define SYMBOL(p)       (mem_get(p)->data->symbol)
#define TABLE(p)        (mem_get(p)->data->table)
#define TABLE_PAIR(p)   (mem_get(p)->data->tablePair)
#define SPECIAL_FORM(p) (mem_get(p)->data->specialForm)
#define NATIVE_FUNC(p)  (mem_get(p)->data->nativeFunc)
#define FUNC(p)         (mem_get(p)->data->func)
#define STREAM(p)       (mem_get(p)->data->stream)


#define GLOBAL_ENV_GET(key) tbl_get(GLOBAL_ENV, key)
#define GLOBAL_ENV_SET(key, value) tbl_set(GLOBAL_ENV, key, value)

#endif
